create template
curl --request POST \
--url https://console.vast.ai/api/v0/template \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "Example Template",
"image": "vastai/base-image",
"tag": "latest",
"env": "-e MY_VAR=value -p 8000:8000",
"runtype": "ssh",
"ssh_direct": true
}
'import requests
url = "https://console.vast.ai/api/v0/template"
payload = {
"name": "Example Template",
"image": "vastai/base-image",
"tag": "latest",
"env": "-e MY_VAR=value -p 8000:8000",
"runtype": "ssh",
"ssh_direct": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'Example Template',
image: 'vastai/base-image',
tag: 'latest',
env: '-e MY_VAR=value -p 8000:8000',
runtype: 'ssh',
ssh_direct: true
})
};
fetch('https://console.vast.ai/api/v0/template', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://console.vast.ai/api/v0/template",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'name' => 'Example Template',
'image' => 'vastai/base-image',
'tag' => 'latest',
'env' => '-e MY_VAR=value -p 8000:8000',
'runtype' => 'ssh',
'ssh_direct' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://console.vast.ai/api/v0/template"
payload := strings.NewReader("{\n \"name\": \"Example Template\",\n \"image\": \"vastai/base-image\",\n \"tag\": \"latest\",\n \"env\": \"-e MY_VAR=value -p 8000:8000\",\n \"runtype\": \"ssh\",\n \"ssh_direct\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://console.vast.ai/api/v0/template")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"name\": \"Example Template\",\n \"image\": \"vastai/base-image\",\n \"tag\": \"latest\",\n \"env\": \"-e MY_VAR=value -p 8000:8000\",\n \"runtype\": \"ssh\",\n \"ssh_direct\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://console.vast.ai/api/v0/template")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"name\": \"Example Template\",\n \"image\": \"vastai/base-image\",\n \"tag\": \"latest\",\n \"env\": \"-e MY_VAR=value -p 8000:8000\",\n \"runtype\": \"ssh\",\n \"ssh_direct\": true\n}"
response = http.request(request)
puts response.read_body{
"success": true,
"msg": "Template Created Successfully! New Template ID: 123456",
"template": {
"name": "<string>",
"id": 123,
"hash_id": "<string>"
}
}{
"success": false,
"error": "invalid_args",
"msg": "Template name is required"
}Templates
create template
Creates a new template for launching instances.
Templates store default configuration values that can be used when creating instances. When an instance is created with a template reference, template values serve as defaults that can be overridden by request parameters.
For detailed usage, see Creating and Using Templates with API.
CLI Usage: vastai create template --name <name> --image <image> [options]
POST
/
api
/
v0
/
template
create template
curl --request POST \
--url https://console.vast.ai/api/v0/template \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "Example Template",
"image": "vastai/base-image",
"tag": "latest",
"env": "-e MY_VAR=value -p 8000:8000",
"runtype": "ssh",
"ssh_direct": true
}
'import requests
url = "https://console.vast.ai/api/v0/template"
payload = {
"name": "Example Template",
"image": "vastai/base-image",
"tag": "latest",
"env": "-e MY_VAR=value -p 8000:8000",
"runtype": "ssh",
"ssh_direct": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'Example Template',
image: 'vastai/base-image',
tag: 'latest',
env: '-e MY_VAR=value -p 8000:8000',
runtype: 'ssh',
ssh_direct: true
})
};
fetch('https://console.vast.ai/api/v0/template', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://console.vast.ai/api/v0/template",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'name' => 'Example Template',
'image' => 'vastai/base-image',
'tag' => 'latest',
'env' => '-e MY_VAR=value -p 8000:8000',
'runtype' => 'ssh',
'ssh_direct' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://console.vast.ai/api/v0/template"
payload := strings.NewReader("{\n \"name\": \"Example Template\",\n \"image\": \"vastai/base-image\",\n \"tag\": \"latest\",\n \"env\": \"-e MY_VAR=value -p 8000:8000\",\n \"runtype\": \"ssh\",\n \"ssh_direct\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://console.vast.ai/api/v0/template")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"name\": \"Example Template\",\n \"image\": \"vastai/base-image\",\n \"tag\": \"latest\",\n \"env\": \"-e MY_VAR=value -p 8000:8000\",\n \"runtype\": \"ssh\",\n \"ssh_direct\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://console.vast.ai/api/v0/template")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"name\": \"Example Template\",\n \"image\": \"vastai/base-image\",\n \"tag\": \"latest\",\n \"env\": \"-e MY_VAR=value -p 8000:8000\",\n \"runtype\": \"ssh\",\n \"ssh_direct\": true\n}"
response = http.request(request)
puts response.read_body{
"success": true,
"msg": "Template Created Successfully! New Template ID: 123456",
"template": {
"name": "<string>",
"id": 123,
"hash_id": "<string>"
}
}{
"success": false,
"error": "invalid_args",
"msg": "Template name is required"
}Body
application/json